Subject: G9 requirement upon LDAP, not LDUP

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Sun, 08 Apr 2001 20:23:03 -0700

draft-ietf-ldup-replica-req-08.txt:
> G9.  LDAP replication SHOULD support replication of directoryOperation
> and distributedOperation attribute types defined in standards track
> LDAP extensions.  Future standards track specifications MUST include a
> "Replication Considerations" section which indicates how and whether
> the new feature operates in a replicated environment.

The latter sentence states a requirement not upon the LDUP, but upon
future LDAP specifications.  It is my opinion that such requirements
are outside the scope of this document and this group.  Even it
were in scope, I believe it's inappropriate for this document
to require designers of future LDAP extensions to detail how they
might work with a ''work in progress''.   I call for this sentence
be stricken from the document.

This is not to say that designers of extensions should ignore
such considerations.  Designers of extensions should consider all
aspects of the LDAP/X.500 data and service models including
replication.

Kurt

---

From: "Ed Reed" <[email-masked]>
Date: Sun, 08 Apr 2001 22:36:57 -0600

Gee - I guess I thought we all just sorta wanted to highlight things
that folks should do when they extend LDAP if they expect LDUP
to respond.  Maybe another way to say it is that in the future, 
authors of standards track specifications that change, add, or
delete requirements on LDUP have an obligation to say so in their
documents, rather that asking them to come back to a presumably
defunct by that time LDUP working group, since we all want to sunset 
groups as soon as all their official work is done.

What's the deal, Kurt?  Of course LDUP can't put requirements on
other groups.  But it does need to put future authors on notice
that LDUP is not required to have anticipated all their requirements,
and to note that it would be only polite for them to note anything
in their future documents that seriously affects users of LDUP.  Isn't
that common sense?

Rather than strike it, propose rewording that accomplishes that notice.

Ed

=================
Ed Reed
Reed-Matthews, Inc.
+1 801 796 7065
http://www.Reed-Matthews.COM

>>> "Kurt D. Zeilenga" <[email-masked]> 04/08/01 09:23PM >>>

Kurt

---

From: "Kurt D. Zeilenga" <[email-masked]>
Date: Sun, 08 Apr 2001 23:57:25 -0700

At 10:36 PM 4/8/01 -0600, Ed Reed wrote:
>to respond.

This document details requirements upon LDUP, not to highlight
things folks should do when they extend LDAP if they expect LDUP
WG to respond.

>Maybe another way to say it is that in the future,

I think we're talking about two different "futures".  I'm
talking about a future which starts immediate after publication
of the requirements I-D as an RFC.  You seem to be talking about
some other future.

If LDUP has requirements upon future LDAP extensions, then the
LDUP requirements document should state a requirement that the
LDUP specification state such a requirement.

>Of course LDUP can't put requirements on other groups.

Then don't.

>But it does need to put future authors on notice

It who?  This I-D or this group?  I'll assume this I-D.

The purpose of this I-D is to detail anticipated replication
issues and detail appropriate LDUP requirements.  Obviously it
cannot anticipate all issues.  However, I note, the LDUP WG
would be under some obligation to address technical issues
which might be later raised.  Of course, LDUP might address a
particular issue by saying "no, that's out of scope of our
documented requirements."

>in their future documents that seriously affects users of LDUP.

It would be polite to ask designers of LDUP to raise issues
they might have with the designs of other works and it would
be polite to ask designers of other works to raise issues they
might have with LDUP.

>Isn't that common sense?

Being polite makes common sense.  But I'm not sure it makes
sense to detail a LDUP requirement that says designers should
be polite.

Kurt

---

From: Christopher Apple <[email-masked]>
Date: Mon, 9 Apr 2001 03:37:08 -0400

I recall that this requirement has been around for quite some time with
the present wording - which represents WG consensus. Kurt's is the only
dissenting opinion that I recall seeing - but I'm writing this without
taking
another look at mailing list archives.

One of the authors of the document that Kurt is commenting should post
the earliest known revision number of that document containing this
requirement so that I can plow through the mailing list to verify
that Kurt's opinion is indeed the only dissenting one since the time
this requirement was modified (if ever) to the present wording.

I agree with Ed's basic points below. It would not be wise to
just remove such a requirement from a document. Reducing the strength
of the requirement from MUST to SHOULD might be a more reasonable
compromise.

However, before that change could be made - it must represent the consensus
of
the WG....and so far - I've only seen postings about either side of this
from
two WG participants. That's not enough to justify changing it at all in my
opinion.

Chris Apple
Program Manager - Directory Services
United Messaging Inc.
http://www.unitedmessaging.com
[email-masked]
<mailto:[email-masked]> 
(V) 610-425-2860

> -----Original Message-----
> From: Ed Reed [mailto:[email-masked]]
> Sent: Monday, April 09, 2001 12:37 AM
> To: [email-masked]; [email-masked]
> Subject: Re: G9 requirement upon LDAP, not LDUP
> 
>

---

From: Christopher Apple <[email-masked]>
Date: Mon, 9 Apr 2001 15:17:02 -0400

John and I can certainly look at scope issues and will.

I didn't intend to squash discussion. People are free to comment
on this issue as they always are on the mailing list. I was pointing
out that so far - we've only heard something from two people. So, more
discussion is required about this topic on the list before consensus
can be gauged.

Generally, when a requirement shows up in a WG document, its either
a proposal for the WG to consider or represents consensus of the WG.
Rick Huber pointed out to me in a private reply that this requirement
was actually new as of the -07 revision of the document. So, my recollection
was not correct. As far as judging consensus based on no discussion of the
issue in the mailing list, please take note that I mentioned (using
different
words) in my reply to your posting that I still needed to do that sort
of audit to confirm (or refute, though I did not specifically use that word)
my recollection.

I want to hear more from others about a proposed resolution to your
opinion/posting before a change of this nature is made to the draft.

Strictly speaking without my co-chair hat on, I think its certainly
appropriate to recommend in a requirements document for LDAPv3 Replication
(its just called LDUP because of a set of words that someone culled together
before one of the first BOF meetings on the topic) that future LDAPv3
extensions should include a section on how that particular extension is
affected by or could potentially affect replication. I do not have a
strong feeling at this point about the strength that we should install
into that requirement.

Speaking as co-chair, I need to see more discussion of the issue before
consensus can be gauged. 

Chris Apple

> From: Kurt D. Zeilenga [mailto:[email-masked]]
> Sent: Monday, April 09, 2001 10:58 AM
> To: Christopher Apple
> Cc: [email-masked]
> Subject: RE: G9 requirement upon LDAP, not LDUP
> 
> 
> Christopher,
> 
> Maybe I was unclear in the nature of my objection.  I do not believe
> the sentence in question states a technical requirement upon the
> design of LDUP.  It states a requirement upon the design and
> specification of other LDAP extensions.  I ask that you or John,
> the WG chairs, review the charter and make a determination whether
> the LDUP WG is tasked to develop requirements upon the developers
> of other LDAP extensions and then to take action based upon this
> determination.
> 
> If you believe it is within scope, I object to you squashing
> discussion on this issue and ask you reconsider.
> 
> There was no such requirement in revision -06 which went up for
> WG Last Call.  At last call, an issue was discussed regarding
> "active" and "passive" data and I believe the eventual consensus
> was to replace this characterization with the userApplications v.
> operational characterization.
> 
> This sentence, however, was not part of that discussion.  I cannot
> find any prior discussion as to why it was added and I believe my
> posting of yesterday initiated the first discussion regarding the
> addition.  It is unclear to me how one could draw what the WG
> consensus regarding an issue which has yet to be discussed.
> 
> Thanks, Kurt
>

---

From: Christopher Apple <[email-masked]>
Date: Wed, 11 Apr 2001 12:42:02 -0400

RE: the issue of whether or not this requirement is
in-scope for LDUP.....I'm conferring with Patrik, John,
Mark, and Roland.

Patrik is out on holiday now - it'll likely be a bit longer
before we get some AD guidance on this matter.

Outside of the scope issue - I still think the discussion
we've been having on the LDUP list is useful. Regardless
of where this sort of requirement ends up (or doesn't)
it is a good thing to discuss the usefulness of such
a requirement in the first place.

Chris Apple

---

From: "Christopher Apple(EXCHANGE)" <[email-masked]>
Date: Wed, 11 Apr 2001 14:21:21 -0400

Comments below....

Chris Apple

> Sent: Wednesday, April 11, 2001 1:57 PM
> To: Christopher Apple
> Cc: Richard Huber; [email-masked]
> At 12:17 PM 4/11/01 -0400, Christopher Apple wrote:
> >And that's a key point related to this discussion I believe. Until
> >this requirement is published within an RFC, it carries no real
> >weight for anyone outside of the Editors and participants of the
> >LDUP WG.
> 
> I disagree here.  This is being published as an Informational RFC.
> It will have weight upon the LDUP WG only because the LDUP charter
> says that the approach used to produce LDUP will be driven by these
> requirements.  WG/Individuals producing of other Standard Track LDAP
> extensions have some obligations to consider the work of others,
> I don't think such a requirement carries any real weight upon the
> WG/Individuals.
> 
> I am quite concerned that such a requirement statement would lead to
> appeals on future documents based not on technical issues, but based
> upon compliance with an Informational RFC which they were not bound to
> though some charter or other process mechanism.
> 
> >"Good" is of course subjective, and that's something
> >that the collective IETF LDAP community should decide on
> >a case-by-case basis.
> 
> Yes!  I trust that the Internet Process will ensure that any
> LDAP replication issues anyone might have will be addressed in
> future Standard Track specifications.
>

In principal, we agree then that the actual inclusion of such a section
should be decided according to normal IETF processes. That doesn't mean
that you have to avoid reducing to writing a non-mandatory
requirement to include a replication considerations section
in future LDAP extension I-Ds, at least as a reminder that
there should be a good reason for not doing so. That may be our
most significant point of disagreement.

Lets leave the issue of whether or not it belongs in this document
alone until we hear from Patrik. I think we have to do that since you
have requested that its scope be reviewed.

With that said, I do feel very strongly that such a requirement
should be written down in *some* document that is intended to
result in LDAPv3 Extension editors being required to add a section
on replication considerations or have a good reason for not doing so
(and I can think of no good reason for not doing so, even if the
section contains boiler plate text stating that it is not known
whether this extension will work in a replicated environment or not).

Whether or not a requirement of this nature belongs in this document,
I'm beginning to doubt somewhat myself. But I'm not quite where you
are just yet....
 
> >> As this is not a requirement upon LDUP, I would not enumerate
> >> it as such.  I would instead place in the Introduction.
> >>
> >
> >I don't follow what you mean by the above statement.
> 
> I was suggesting the alternative statement I offered be placed in
> the Introduction of the LDUP Requirements I-D.

OK. Got what you are suggesting. Think we need to wait for Patrik to
respond.

Chris.

---

From: "Christopher Apple(EXCHANGE)" <[email-masked]>
Date: Wed, 11 Apr 2001 14:29:48 -0400

> -----Original Message-----

[SNIP]

> whether this extension will work in a replicated environment or not).

Note that I've changed my own position on what a good reason
could be for not including such a document section....I don't
think its a good idea to leave the section out at all. Even
if all it says is the equivalent of "not considered," I really want
to know that as a service implementer. I believe that drafts produced
before LDUP concludes its work should have such a section. The content
of that section I'm flexible about. I doubt that it would be
a good idea to refer to LDUP as a WG or as "work-in-progress" by
referencing the WG acronym in such sections. But until we have a
real situation, debating that issue seems moot.

[SNIP]

Chris Apple